2021-03-21  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Update version to 1.1.
	* doc/gendocs_template: Likewise.

2021-03-21  Jose E. Marchesi  <jemarch@gnu.org>

	* NEWS: Update for 1.1.

2021-03-19  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/Makefile.am (dist_lisp_DATA): Avoid byte-compiling emacs
	modes.

2021-03-17  Kostas Chasialis <sdi1600195@di.uoa.gr>

	* doc/gen-pvm-insns.sh: A more portable version of the script.
	* cfg.mk (sc_tests_listed_in_makefile_am): Now correctly finds
	tests on srcdir builds.

2021-03-17  Egeyar Bagcioglu  <egeyar@gmail.com>

	* libpoke/ios-dev-file.c (ios_dev_file_open): Create files with
	adequate flags.

2021-03-17  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-ios.h: Rename pk_open_ios to pk_open_file.
	* poke/pk-ios.c (pk_open_file): Likewise.
	(pk_open_file): Pass set_cur_p to pk_ios_open.
	* poke/pk-cmd-ios.c (pk_cmd_file): Reflect rename.
	* poke/poke.c (parse_args_2): Use pk_ios_open instead of
	pk_open_file.

2021-03-15  Egeyar Bagcioglu  <egeyar@gmail.com>

	* .gitignore: Add /build /gl-libutils /doc/poke.text and tags

2021-03-16  Thomas Weißschuh <thomas@t-8ch.de>

	* etc/Makefile.am: Distribute Emacs syntax highlighting.

2021-03-15  Egeyar Bagcioglu  <egeyar@gmail.com>

	* libpoke/ios-dev-file.c (ios_dev_file_convert_flags): New function.
	(ios_dev_file_open): Open files with the right flags via "open".

2021-03-15  Egeyar Bagcioglu  <egeyar@gmail.com>

	* doc/poke.texi: Remove IOS_F_TRUNCATE.
	* etc/poke-mode.el: Likewise.
	* etc/poke.vim: Likewise.
	* libpoke/ios-dev-file.c (ios_dev_file_open): Likewise.
	* libpoke/ios-dev-nbd.c (ios_dev_nbd_open): Likewise.
	* libpoke/libpoke.h: Likewise.
	* libpoke/ios.h: Likewise.
	* libpoke/pkl-rt.pk: Likewise.

2021-03-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y (struct_type_field): Adapt to
	struct_type_field_constraint_and_init.
	(struct_type_field_constraint_and_init): Rename from
	struct_type_field_constraint_or_init.
	* doc/poke.texi (Field Initializers): Document that both
	initializers and constructors are valid.
	* testsuite/poke.pkl/field-init-diag-3.pk: Remove test.
	* testsuite/poke.pkl/field-init-9.pk: New test.
	* testsuite/poke.pkl/field-init-10.pk: Likewise.
	* testsuite/poke.pkl/field-init-11.pk: Likewise.
	* testsuite/poke.pkl/field-init-12.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2021-03-13  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-dump.pk: Round :size up to the next byte instead of
	truncating.
	* testsuite/poke.cmd/dump-9.pk (pk_dump_ascii): New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2021-03-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_ass_stmt): Use SSET instead of
	SSETI for values mapped in non-strict mode.
	* testsuite/poke.map/nsmap-5.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2021-03-13  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Handling Incorrect Data): New section.

2021-03-13  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Non-strict Mapping): Texinfo fix.

2021-03-12  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Writing Binary Utilities): New chapter.
	(Poke Scripts): New section.
	(Filters): Likewise.
	(Command-Line Arguments): Likewise.

2021-03-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def: define instruction `rev'.
	* libpoke/pkl-asm.c (pkl_asm_insn_rev): New function.
	(pkl_asm_insn): Support REV.
	* libpoke/pkl-gen.c (pkl_gen_pr_print_stmt): Use the rev
	macro-instruction.
	(pkl_gen_pr_funcall): Likewise.
	(pkl_gen_pr_func): Likewise.

2021-03-11  Jose E. Marchesi  <jemarch@gnu.org>

	* cfg.mk (sc_unitalicised_etc): Change rule so it is not triggered
	by mentions to files in etc/.
	* utils/pk-strings.in: Remove trailing whitespaces.

2021-03-10  Jose E. Marchesi  <jemarch@gnu.org>

	* utils/pk-strings.in: New file.
	* utils/Makefile.am: Rules for pk-strings.

2021-03-10  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-repl.c (banner): Avoid incomplete sentences in
	translatable strings.

2021-03-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk: Do not raise an exception if HOME is not
	defined in the environment.

2021-03-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_struct_type_field): Use
	pkl_ast_type_mappable_p to decide which field types are valid.
	* testsuite/poke.pkl/struct-types-diag-12.pk: New test.
	* testsuite/poke.pkl/struct-types-diag-13.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-03-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_struct_type_field): Use
	pkl_ast_type_mappable_p to decide which field types are valid.
	* testsuite/poke.pkl/struct-types-diag-12.pk: New test.
	* testsuite/poke.pkl/struct-types-diag-13.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-03-08  Jose E. Marchesi  <jemarch@gnu.org>

	* .x-sc_prohibit_path_max_allocation: New file.

2021-03-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/ios-dev-file.c (ios_dev_file_open): Handle `open' flags
	better.
	* poke/pk-save.pk (save): Adapt to new handling of flags in the
	file IOD.

2021-03-07  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Struct Methods): Explain how methods have the
	ability to break data integrity.

2021-03-07  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Check for recfix.
	* cfg.mk (sc_recfix_poke_rec): New rule.

2021-03-06  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/Makefile.am (check-DEJAGNU): `make check' now exits
	with an error status if runtest fails.

2021-03-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-val.h (PVM_VAL_OFF_UNIT_GIGIBYTES): Avoid using a LU
	suffix, fixing 32-bit.
	(PVM_VAL_OFF_UNIT_GIGABYTES): Likewise.

2021-03-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_POWOP_SIGNED): Avoid using the L suffix,
	fixing 32-bit.

2021-03-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_ps_array): Avoid using size_t
	variables, fixing 32-bit.

2021-03-06  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Set NBDKIT to `no' if --disable-libnbd is used.

2021-03-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_ps_print_stmt): Fix error
	message.

2021-03-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_PRINTL): make more portable.
	(printlu): Adapt accordingly.
	(printl): Likewise.
	(PVM_PRINTI): Make more portable.
	(printiu): Adapt accordingly.
	(printi): Likewise.

2021-03-05  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_type_array): Use pkl_asm_note
	instead of pkl_asm_insn (...PKL_INSN_NOTE).

2021-03-05  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-env.c (pvm_env_register): Fix for 32-bit hosts.

2021-03-05  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Mapping Functions): New section.
	(Programming Emacs Modes): New chapter.
	(poke-mode): New section.
	(ras-mode): Likewise.
	(poke-map-mode): Likewise.

2021-03-04  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Strings are not Arrays): New section.

2021-03-03  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Getting Started): New section.

2021-03-02  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-set.c (pk_cmd_set_oacutoff): Fix error message.
	(pk_cmd_set_obase): Likewise.
	(pk_cmd_set_endian): Likewise.
	(pk_cmd_set_nenc): Likewise.
	(pk_cmd_set_auto_map): Likewise.
	(pk_cmd_set_prompt_maps): Likewise.
	(pk_cmd_set_pretty_print): Likewise.
	(pk_cmd_set_odepth): Likewise.
	(pk_cmd_set_oindent): Likewise.
	(pk_cmd_set_omaps): Likewise.
	(pk_cmd_set_omode): Likewise.
	* poke/pk-cmd-ios.c (pk_cmd_file): Likewise.
	* poke/pk-repl.c (banner): Likewise.

2021-03-02  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (ains): Raise E_inval with a more informative
	message.
	(map): Likewise.
	(reloc): Likewise.
	(ureloc): Likewise.

2021-03-02  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Padding and Alignment): New section.

2021-02-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (CASE_INTEGRAL): Emit a compilation error
	for INTEGRAL/OFFSET and INTEGRAL/^OFFSET.
	* testsuite/poke.pkl/div-integers-diag-2.pk: New test.
	* testsuite/poke.pkl/cdiv-integers-diag-2.pk: Likewise.
	* testsuite/poke.pkl/mod-integers-diag-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-28  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.time/time32.pk: Do not use host endianness in the
	test.

2021-02-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/Makefile.am (MOSTLYCLEANFILES): handle removal of files
	created by AX_CREATE_PKGCONFIG_INFO at make distclean.

2021-02-28  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* poke/pk-cmd-map.c (SET_TO_CUR_IOS_ID): Add new macro to find the
	current IOS id.
	(pk_cmd_map_create): Use `SET_TO_CUR_IOS_ID` macro.
	(pk_cmd_map_remove): Likewise.
	(pk_cmd_map_show): Likewise.
	(pk_cmd_map_entry_add): Likewise.
	(pk_cmd_map_entry_remove): Likewise.
	(pk_cmd_map_load): Likewise.
	(pk_cmd_info_maps): Likewise.

2021-02-27  Sergei Trofimovich <slyfox@gentoo.org>

	* pickles/Makefile.am (dist_pickles_DATA): Package rest of *.pk files
	to tarball: mcr.pk dwarf-expr.pk dwarf-info.pk id3v2.pk.

2021-02-27  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pk-val.c (pk_val_offset): Return PK_NULL if the given
	value is not mapped.
	* testsuite/poke.libpoke/values.c (test_simple_values): Check that
	pk_val_offset returns PK_NULL for simple values.

2021-02-27  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-map-tab.y (tagged_value_list): Fix error messages.
	(check_entry_duplicated_tags): Likewise.
	(pk_map_printf_error): Make static.

2021-02-27  Morten Linderud  <morten@linderud.pw>

	* poke/poke.pk: Fix setting of map_load_path when XDG_DATA_HOME is
	set.

2021-02-27  Sergei Trofimovich <slyfox@gentoo.org>

	* doc/poke.texi (Describe-Compute): fix example and wording.

2021-02-26  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/Makefile.am (EXTRA_DIST): Distribute etc/poke.rec.

2021-02-26  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Update version number to 1.0.
	* NEWS: Update for 1.0.
	* doc/gendocs_template: Likewise.

2021-02-25  Indu Bhagat  <indu.bhagat@oracle.com>

	* pickles/ctf.pk (ctf_kind_str): Add string for slice.
	(CTF_Dictionary): New type.
	(CTF_Preamble): Add _print function.
	(CTF_Header): Likewise.
	(ctf_get_header): Rename to ctf_get_dict.

2021-02-25  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-map.c (pk_cmd_map_save): Show a "not implemented
	message".
	* poke/pk-cmd.c (pk_cmd_exec_1): Invoke commands even if glob
	fails.
	* poke/pk-cmd-misc.c (pk_cmd_exit): Remove spurious code.

2021-02-25  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Standard Units): Update to reflect std.pk.

2021-02-24  Egeyar Bagcioglu  <egeyar@gmail.com>

	* poke/pk-cmd-ios.c (pk_cmd_close): Replace "The current file is now
	`%s'.\n" with "The current IOS is now `%s'.\n" for correctness and
	consistency.

2021-02-24  Egeyar Bagcioglu  <egeyar@gmail.com>

	* libpoke/ios-dev-stream.c (ios_dev_stream_pread): Change internal
	implementation.

2021-02-24  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/gendocs_template: Use our own gendocs.sh template.

2021-02-24  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Structured Integers): New section.

2021-02-24  Indu Bhagat  <indu.bhagat@oracle.com>

	* utils/pk-elfextractor.in: use get_section_name instead of get_string.

2021-02-24  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Maps and Map-files): New chapter.
	(Editing using Variables): New section.
	(poke Maps): Likewise.
	(Loading Maps): Likewise.
	(Multiple Maps): Likewise.
	(Auto-map): Likewise.
	(Constructing Maps): Likewise.
	(Predefined Maps): Likewise.

2021-02-23  Indu Bhagat  <indu.bhagat@oracle.com>

	* doc/poke.texi: fix minor typos.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (pk_print_version): Print version even with no hand.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Change version to 0.91.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-term.c (lookup_color_code): Define only #if
	HAVE_TEXTSTYLE_ACCESSORS_SUPPORT.
	(register_color): Likewise.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-lex.l: Fix detection of overflow in signed integer
	literals.
	* testsuite/poke.pkl/cdiv-integers-overflow-2.pk: Update test.
	* testsuite/poke.pkl/neg-int-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/neg-int-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/mod-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/div-integers-overflow-diag-1.pk: Likewise.
	* testsuite/poke.pkl/div-integers-overflow-2.pk: Likewise.
	* testsuite/poke.libpoke/pk_equal_uint.test: Likewise.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/lib/poke.exp (poke-tmpdir): New procedure.
	* testsuite/poke.repl/repl.exp: Do not rely on Tcl 8.6.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/lib/poke-dg.exp (dg-data): Avoid using the unportable
	printf %q.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* AUTHORS: Add Indu.
	* etc/hacking.org: Add Indu to the write-after-approval list.
	* HACKING: Regenerate.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_POWOP_SIGNED): Define.
	(powi): Use PVM_POWOP_SIGNED.
	(powl): Likewise.
	* testsuite/poke.pkl/pow-integers-overflow-1.pk: New test.
	* testsuite/poke.pkl/pow-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/pow-integers-3.pk: Update test.
	* testsuite/poke.pkl/pow-offsets-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-fold.c (OP_UNARY_II): Detect overflow constant
	folding negation.
	* libpoke/pvm.jitter (PVM_NEG_SIGNED): Define.
	(negi): Use PVM_NEG_SIGNED.
	(negl): Likewise.
	* testsuite/poke.pkl/neg-int-overflow-diag-1.pk: New test.
	* testsuite/poke.pkl/neg-int-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/neg-int-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/neg-int-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-3.pk: Update test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-fold.c (OP_BINARY_III): Detect overflow constant
	folding signed remainder.
	* libpoke/pvm.jitter (PVM_MOD_SIGNED): Define.
	(modi): Use PVM_MOD_SIGNED.
	(modl): Likewise.
	* testsuite/poke.pkl/mod-integers-overflow-diag-1.pk: New test.
	* testsuite/poke.pkl/mod-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/mod-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/mod-integers-overflow-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_MUL_SIGNED): Simplify a bit.
	(PVM_DIV_SIGNED): Likewise.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-fold.c (OP_BINARY_III): Error while constant folding
	signed division and ceil-division if the operation would result in
	overflow.
	* libpoke/pvm.jitter (PVM_DIV_SIGNED): Define.
	(divi): Use PVM_DIV_SIGNED.
	(divl): Likewise.
	* testsuite/poke.pkl/div-integers-overflow-diag-1.pk: New test.
	* testsuite/poke.pkl/div-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/cdiv-integers-overflow-diag-1.pk: Likewise.
	* testsuite/poke.pkl/cdiv-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/div-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/div-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/div-integers-overflow-3.pk: Likewise.
	* testsuite/poke.pkl/cdiv-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/cdiv-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/cdiv-integers-overflow-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>w

	* libpoke/pkl-fold.c (OP_BINARY_III): Error while constant folding
	signed multiplication if the operation would result in overflow.
	* libpoke/pvm.jitter (PVM_SUB_SIGNED): Define.
	(muli): Use PVM_SUB_SIGNED.
	(mull): Likewise.
	* libpoke/std.pk (atoi): Avoid overflow.
	* testsuite/poke.std/std-test.pk: Update test.
	* testsuite/poke.pkl/mul-integers-overflow-diag-1.pk: New test.
	* testsuite/poke.pkl/mul-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/mul-integers-overflow-diag-3.pk: Likewise.
	* testsuite/poke.pkl/mul-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/mul-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/mul-integers-overflow-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-fold.c (OP_BINARY_III): Error while constant folding
	signed subtraction if the operation would result in overflow.
	* libpoke/pkl-lex.l: Fix promotion of constants to 64-bit.
	* libpoke/pvm.jitter (PVM_SUB_SIGNED): Define.
	(subi): Use PVM_SUB_SIGNED.
	(subl): Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-diag-1.pk: New test.
	* testsuite/poke.pkl/sub-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-diag-3.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-fold.c (OP_BINARY_III): Error on overflow on certain
	signed arithmetic operations.
	* libpoke/pvm.jitter (PVM_ADD_SIGNED): Define.
	(addi): Use PVM_ADD_SIGNED.
	(addl): Likewise.
	* testsuite/poke.pkl/add-integers-overflow-1.pk: New test.
	* testsuite/poke.pkl/add-integers-overflow-2.pk: Likewise.
	* testsuite/poke.pkl/add-integers-overflow-3.pk: Likewise.
	* testsuite/poke.pkl/add-integers-overflow-4.pk: Likewise.
	* testsuite/poke.pkl/add-integers-overflow-5.pk: Likewise.
	* testsuite/poke.pkl/add-integers-overflow-diag-1.pk: Likewise.
	* testsuite/poke.pkl/add-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/add-integers-overflow-diag-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-promo.c (promote_node): Make sure to set `restart'
	in any case.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-map.c (entry_name_to_varname): Use PRIu64 instead of %lu
	in printf format string.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Fix --disable-feature In optional features that
	use PKG_CHECK_MODULES.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Invoke gl_HOST_CPU_C_ABI_32BIT and ac_define the
	corresponding cpp macro.
	* libpoke/pkl-asm.c (pkl_asm_insn): Use POKE_HOST_32BIT instead of
	the undocumented and unportable __WORDSIZE.
	(pkl_asm_note): Likewise.
	* libpoke/pvm-program.c (pvm_program_append_push_instruction):
	Likewise.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (libpoke_modules): Add intprops.
	(gui_modules): Add alloca.
	(gnulib_modules): Add host-cpu-c-abi.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (EC_overflow): Define.
	(E_overflow): Likewise.
	* libpoke/pvm.h (PVM_E_OVERFLOW): Define.
	(PVM_E_OVERFLOW_MSG): Likewise.
	(PVM_E_OVERFLOW_ESTATUS): Likewise.
	* doc/poke.texi (Exceptions): Document E_overflow.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (libpoke_modules): Add the free-posix module.

2021-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.pk: Do not assume HOME is defined in the environment.

2021-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-misc.c (quit_cmd): Define.
	* poke/pk-cmd.c (dot_cmds): Add quit_cmd.
	* doc/poke.texi (quit command): New section.

2021-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/hacking.org: Add David Faust to the write after approval
	list.

2021-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (buildreq): Fix indentation.

2021-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/std.pk (crc32): Avoid too long lines.

2021-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Invoking poke): Leave empty lines between
	argument descriptions, and add missing arguments.

2021-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (pk_print_version): Print the poke hand
	conditionally.
	(parse_args_2): Do not print the poke hand in the --version
	output.
	* poke/pk-repl.c (banner): DO print the poke hand as part of the
	poke banner :)
	* poke/pk-cmd-misc.c (pk_cmd_version): Likewise.

2021-02-21  Indu Bhagat  <indu.bhagat@oracle.com>
	    Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-save.pk (save): Fix invocation to copy.
	* testsuite/poke.cmd/save-2.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2021-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* Makefile.am (update-hacking): New maintenance rule to regenerate
	HACKING from etc/hacking.org.
	* HACKING: Update.
	* DEV-NEWS: Update.

2021-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/Makefile.am (.pks.pkc): Fix typo in command.

2021-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk: Fix typo in comment
	.

2021-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (print_help): Use a puts statement for each header
	and option, and do not finish them with periods.
	* poke/pk-cmd-ios.c (pk_cmd_load_file): Use pk_fatal and an
	uniform message when out of memory.
	(pk_cmd_mem): Likewise.
	* poke/pk-map.c (entry_name_to_varname): Likewise.
	* poke/poke.h (pk_assert_alloc): Likewise.
	* libpoke/pkl-trans.c (pkl_trans1_ps_print_stmt): Start error
	messages with a lower case.

2021-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* man/Makefile.am (poke.1): Avoid TAB-8-space indentation in
	Makefile.
	* libpoke/Makefile.am: Spell time-stamp.
	* poke/Makefile.am: Likewise.

2021-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Set POKE_AWK and do not error out at configure
	time if no suitable awk is found.
	* libpoke/Makefile.am (.pks.pkc): Check that AWK is powerful
	enough for RAS.  Error out otherwise.

2021-02-20  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* testsuite/poke.mi-json/mi-json.c (test_json_pk_sct): Remove unused
	variable(s).
	(test_val_to_json): Likewise.
	(read_json_object): Change the type of `cap` to `ssize_t` to make the
	compiler happy (-Wsign-compare).

2021-02-20  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* libpoke/pvm.jitter (PVM_PRINTI): Fix bit-depth of printed negative
	values in base 8 and 16.
	(PVM_PRINTL): Likewise.
	* testsuite/poke.pkl/printf-28.pk: New test.
	* testsuite/poke.pkl/printf-29.pk: Likewise.
	* testsuite/poke.pkl/printf-30.pk: Likewise.
	* testsuite/poke.pkl/printf-31.pk: Likewise.
	* testsuite/poke.pkl/printf-32.pk: Likewise.
	* testsuite/poke.pkl/printf-33.pk: Likewise.
	* testsuite/poke.pkl/printf-34.pk: Likewise.
	* testsuite/poke.pkl/printf-35.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2021-02-19  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/dwarf-frame.pk (Dwarf_CIE): Fix constant.

2021-02-19  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* testsuite/poke.mi-json/mi-json.c (test_json_to_val_to_json):
	Simplify the JSON file selection loop.

2021-02-16  Indu Bhagat  <indu.bhagat@oracle.com>

        * pickles/ctf.pk (CTF_Header): Use offset field type for cth_lbloff.
        (CTF_Integer_Type): Use integral struct.
        (CTF_Float_Type): Likewise.
        (CTF_Slice): New definition.
        (CTF_Type): CTF_KIND_ENUM is followed by a vlen number of enum records.
        CTF_KIND_FUNCTION has a trailing padding of 4 bytes if the number of
        function arguments is odd. Support CTF Slice.
        (ctf_string): Use correct offset to the CTF string section.

2021-02-16  David Faust  <david.faust@oracle.com>

	* pickles/btf.pk (BTF_Int): Make `offset` and `bits` into offset types.
	(BTF_Section): Properly use header type_off and str_off.
	(btf_types): Remove now-redundant function.
	(btf_strings): Likewise.
	* pickles/btf-dump.pk (btf_dump_int): Account for above type changes.

2021-02-15  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/ustar.pk: New file.
	* pickles/Makefile.am (dist_pickles_DATA): Add ustar.pk.

2021-02-15  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Update version to 0.90.
	* NEWS: Adapt to 0.90.

2021-02-15  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.pk (auto_map): Initialize to an empty array.

2021-02-15  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pkl/ass-struct-int-5.pk: New test.
	* testsuite/poke.pkl/ass-struct-int-6.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2021-02-14  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* poke/poke.c (pk_print_version): Update copyright.

2021-02-14  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/btf.pk: Fix typo for UNKNOWN.

2021-02-14  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (parse_args_2): -s doesn't imply that poke runs
	non-interactively.
	(main): Load user configuration file before handling -s arguments.
	(parse_args_1): Handle NO_INIT_FILE_ARG here instead of
	parse_args_2.
	(parse_args_1): Likewise for QUIET_ARG.

2021-02-12  David Faust  <david.faust@oracle.com>

	* pickles/btf-dump.pk: New pickle.
	* pickles/Makefile.am (dist_pickles_DATA): Add `btf-dump.pk`.

2021-02-12  David Faust  <david.faust@oracle.com>

	* pickles/btf.pk (BTF_Type) Make several fields `offset`s where
	appropriate. Correct bitfield to use integral struct. Correct variable
	data for BTF_KIND_STRUCT.
	(BTF_Section) New type.

2021-02-08  David Faust  <david.faust@oracle.com>

	* libbpoke/pkl-anal.c: Forbid anonymous members in unions.
	* pickles/btf.pk (type BTF_Type): Give name to anonymous union member.
	* pickles/ctf.pk (type CTF_Type): Likewise.
	* pickles/dwarf-expr.pk (type Dwarf_Op): Likewise.
	* pickles/dwarf-frame.pk (type Dwarf_CFI): Likewise.
	* testsuite/poke.pkl/union-diag-8.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2021-02-06  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (pk_cmd_source_file): New function.
	(source_cmd): Define.
	* poke/pk-cmd.c (source_cmd): Define.
	(dot_cmds): Add source_cmd.
	* doc/poke.texi (source command): New section.

2021-02-06  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (print_help): --script to --source.
	Rename SCRIPT_ARG to SOURCE_ARG.
	(long_options): Likewise.
	(parse_args_2): Update accordingly.
	* doc/poke.texi (Invoking poke): Update accordingly.

2021-01-28  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* pickles/mbr.pk: New pickle.
	* pickles/Makefile.am (dist_pickles_DATA): Add `mbr.pk`.
	* testsuite/poke.pickles/mbr-test.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2021-01-28  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* libpoke/pkl-gen.pks (struct_writer): Fix bit-offset of mapped
	integral struct.
	* testsuite/poke.map/maps-int-structs-21.pk: New test.
	* testsuite/poke.map/maps-int-structs-22.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-23.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-24.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-25.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-26.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-27.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-28.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2021-01-26  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-env.c (get_registered): The empty string is never
	recognized as the name of a registered declaration.
	* libpoke/pkl-tab.y (struct_type_field): Register anonymous struct
	fields in the lexical environment.
	* testsuite/poke.map/maps-structs-anonfield-1.pk: New test.
	* testsuite/poke.map/maps-structs-anonfield-2.pk: Likewise.
	* testsuite/poke.map/maps-structs-anonfield-3.pk: Likewise.
	* testsuite/poke.pkl/scons-anon-field-1.pk: Likewise.
	* testsuite/poke.pkl/scons-anon-field-2.pk: Likewise.
	* testsuite/poke.pkl/scons-anon-field-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2021-01-25  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* libpoke/pkl-rt.pk (exception_code): New function.
	* doc/poke.texi (Exceptions): Add documentation for `exception_code`.

2021-01-25  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* testsuite/Makefile.am (check-DEJAGNU): Fix `make distcheck`
	failure by removing the INPUTRC file after running the tests.

2021-01-24  Mohammad-Reza Nabipoor  <m.nabipoor@yahoo.com>

	* testsuite/Makefile.am (check-DEJAGNU): Set INPUTRC. Use custom
	INPUTRC config file to explicitly disable bracketed paste mode in
	readline library.

2021-01-03  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (Support nested integral structs): Do not schedule
	for 1.0.

2021-01-02  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Motivation): New section.
	(Dealing with Alternatives): Likewise.
	(Offsets and Sizes): Likewise.

2021-01-01  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Debugging Poke Programs): Demote and relocate.
	(Writing Pickles): Relocate.

2020-12-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.h (struct pk_color): New type.
	(struct pk_term_if): Remove rgb_to_color_fn and modify get_(bg)color_fn
	and set_(bg)color_fn to handle terminal colors.
	* testsuite/poke.libpoke/term-if.h: Adapt to new API.
	* poke/pk-term.c (lookup_color): New function.
	* libpoke/pvm.jitter (pushoc): Adapt to new API.
	(popoc): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Likewise.
	* libpoke/pkl-insn.def: Remove the instruction rgbtoc.
	* doc/poke.texi (Terminal Colors): Update to new semantics.

2020-12-31  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-term.c (dispose_active_classes): Remove unneeded
	function.
	(pk_term_shutdown): Use pop_active_class instead of
	dispose_active_classes.

2020-12-30  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-term.c (pop_active_class): Return a status code.
	(pk_term_end_class): Adapt to new interface.

2020-12-30  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.h (struct pk_term_if): Change end_class_fn
	prototype to return an error code.
	* poke/pk-term.c (pk_term_end_class): Likewise.
	(dispose_active_classes): New function.
	(push_active_class): Likewise.
	(pop_active_class): Likewise.
	(pk_term_class): Push the class.
	(pk_term_end_class): Check for the class, then pop it.
	* testsuite/poke.libpoke/term-if.h (pk_term_end_class): Likewise.
	* libpoke/pvm.jitter (endsc): Raise an exception if the given
	class is invalid.
	* testsuite/poke.pkl/term-class-1.pk: New test.
	* testsuite/poke.pkl/term-class-2.pk: Likewise.
	* testsuite/poke.pkl/term-class-3.pk: Likewise.
	* testsuite/poke.pkl/term-hl-1.pk: Likewise.
	* testsuite/poke.pkl/term-hl-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2020-12-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-val.c (pvm_val_initialize): New function.
	(string_value): New variable.
	(void_type): Likewise.
	(any_type): Likewise.
	(pvm_make_string_type): Reuse unitary value.
	(pvm_make_void_type): Likewise.
	(pvm_make_any_type): Likewise.
	(pvm_val_finalize): Likewise.

2020-12-29  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (@:.vm profile): New section.

2020-12-29  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/hacking.org (Building with profiling support): New section.
	* HACKING: Regenerate.
	* DEV-NEWS: Update.

2020-12-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.h: Prototype for pvm_ref_struct_cstr.
	* libpoke/pvm-val.c (pvm_ref_struct_cstr): New function.
	(pvm_ref_struct): Rewrite to use pvm_ref_struct_cstr.
	* libpoke/pvm.jitter (PVM_RAISE_DIRECT): Use pvm_ref_struct_cstr.
	(pushe): Likewise.

2020-12-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter: Store exception structs in the exceptions
	stack and not pointers.

2020-12-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-val.h (PVM_MAKE_LONG): Define.
	(PVM_MAKE_ULONG): Likewise.
	(PVM_MAKE_LONG_ULONG): Likewise.
	* libpoke/pvm-val.c (pvm_make_long_ulong): Remove function.
	* libpoke/pvm.jitter: Use macros instead of functions to create
	values.

2020-12-28  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Handle --enable-pvm-profiling.
	* libpoke/pvm.c (pvm_print_profile): New function.
	(pvm_reset_profile): Likewise.
	* libpoke/libpoke.c (pk_print_profile): Likewise.
	(pk_reset_profile): Likewise.
	* poke/pk-cmd-vm.c (vm_profile_cmds): Define.
	(vm_profile_cmd): Likewise.
	(vm_cmds): Add vm_profile_cmd.
	(vm_profile_show_cmd): Define.
	(vm_profile_reset_cmd): Likewise.
	(pk_cmd_vm_profile_show): New function.
	(pk_cmd_vm_profile_reset): Likewise.
	* poke/pk-cmd.c (pk_cmd_init): Initialize vm_disas_trie.
	(pk_cmd_shutdown): Dispose of vm_profile_trie.

2020-12-25  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Struct Attributes): New section.

2020-12-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (offset_printer): Fix printing unnammed
	units.
	* testsuite/poke.pkl/printf-27.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2020-12-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-anal.c (pkl_anal1_ps_decl): Clarify error message.
	* testsuite/poke.pkl/struct-method-diag-6.pk: Adapt.

2020-12-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-promo.c (promote_node): New function.
	(pkl_promo_ps_op_div): Use promote_node.
	(pkl_promo_ps_op_binary_intoffstrarr): Likewise.
	(pkl_promo_ps_op_bconc): Likewise.
	(pkl_promo_ps_op_mul): Likewise.
	(pkl_promo_ps_return_stmt): Likewise.
	(pkl_promo_ps_func_arg): Likewise.
	(pkl_promo_ps_print_stmt): Likewise.
